           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June     2005  (modified)   |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CSP_law_SKIP = CSP_law_commut + CSP_law_decompo:

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*****************************************************************

         1. SKIP ;; P
         2. P ;; SKIP
         3. SKIP |[X]| P
         4. P |[X]| SKIP
         5. SKIP |[X]| SKIP
         6. SKIP -- X
         7. SKIP [[r]]

 *****************************************************************)

(*********************************************************
                       SKIP ;; P
 *********************************************************)

(*** domT ***)

lemma domT_Seq_compo_unit_l: "[[SKIP ;; P]]T = [[P]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (force)

(* <= *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
done

(*** domF ***)

lemma domF_Seq_compo_unit_l: "[[SKIP ;; P]]F = [[P]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (elim conjE disjE)
 apply (simp_all add: Evset_def)

(* <= *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
done

(*** domSF ***)

lemma domSF_Seq_compo_unit_l: "[[SKIP ;; P]]SF = [[P]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_Seq_compo_unit_l)
apply (simp add: domF_Seq_compo_unit_l)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_Seq_compo_unit_l: "SKIP ;; P =SF P"
by (simp add: eqSF_def domSF_Seq_compo_unit_l)

(*********************************************************
                       P ;; SKIP
 *********************************************************)

(*** domT ***)

lemma domT_Seq_compo_unit_r: "[[P ;; SKIP]]T = [[P]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (elim conjE exE disjE)
 apply (simp)
 apply (rule memT_prefix_closed, simp)
 apply (simp add: rmtick_prefix_rev)
 apply (simp)
 apply (rule memT_prefix_closed, simp, simp)
 apply (simp)

(* <= *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (insert trace_last_notick_or_tick)
 apply (drule_tac x="t" in spec)
 apply (simp add: not_None_T)
 apply (erule disjE)
  apply (rule disjI1)
  apply (rule_tac x="t" in exI, simp)
  (* *)
  apply (rule disjI2)
  apply (elim conjE exE)
  apply (rule_tac x="s" in exI)
  apply (rule_tac x="[Tick]t" in exI)
  apply (simp)
done

(*** domF ***)

lemma domF_Seq_compo_unit_r: "[[P ;; SKIP]]F = [[P]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (elim conjE exE disjE)
 apply (rule memF_F2, simp, fast)
 apply (rule domSF_F2_F4, simp_all)
 apply (case_tac "notick sa", simp_all)
 apply (rule domSF_T3, simp_all)
 apply (case_tac "notick sa", simp_all)

(* <= *)
 apply (rule)
 apply (simp add: Seq_compo_mem)
 apply (simp add: SKIP_mem)
 apply (insert trace_last_notick_or_tick)
 apply (drule_tac x="s" in spec)
 apply (simp add: not_None_F)
 apply (erule disjE)
  apply (case_tac "Tick : X")
   apply (rule disjI1, simp)
   apply (subgoal_tac "insert Tick X = X", simp, fast)
   (* Tick ~: X *)
   apply (case_tac "s @t [Tick]t ~:t [[P]]T")
    apply (rule disjI1, simp)
    apply (rule domSF_F3[of "[[P]]T" "[[P]]F" _ _ "{Tick}", simplified])
    apply (simp_all)
    (* *)
    apply (rule disjI2)
    apply (rule_tac x="s" in exI)
    apply (rule_tac x="[]t" in exI, simp)
    apply (simp add: Evset_def, fast)
  (* *)
  apply (elim conjE exE, simp)
  apply (rule_tac x="sa" in exI)
  apply (rule_tac x="[Tick]t" in exI)
  apply (simp)
  apply (rule domSF_T2[of _ "[[P]]F"], simp_all)
done

(*** domSF ***)

lemma domSF_Seq_compo_unit_r: "[[P ;; SKIP]]SF = [[P]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_Seq_compo_unit_r)
apply (simp add: domF_Seq_compo_unit_r)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_Seq_compo_unit_r: "P ;; SKIP =SF P"
by (simp add: eqSF_def domSF_Seq_compo_unit_r)

(*********************************************************
                      SKIP |[X]| P
 *********************************************************)

(*** domT ***)

lemma domT_Parallel_preterm_l: 
  "[[SKIP |[X]| (? :Y -> Qf)]]T = [[? x:(Y-X) -> (SKIP |[X]| Qf x)]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
 apply (simp add: Ext_pre_choice_mem)
 apply (insert trace_nil_or_Tick_or_Ev)
 apply (elim disjE conjE exE)
  apply (simp_all)

  apply (drule_tac x="t" in spec)
  apply (simp add: par_tr_not_None)
  apply (erule disjE, simp)
  apply (erule disjE, simp)
  apply (elim conjE exE, simp)
  apply (simp add: par_tr_head)
  apply (simp add: not_None_T)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="sb" in exI, simp)
  apply (simp add: Parallel_mem SKIP_mem)
  apply (fast)

(* Trace_par : u1 : [Tick]t |[X1]|tr []t == False [simp] *)

  apply (drule_tac x="t" in spec)
  apply (simp add: par_tr_not_None)
  apply (erule disjE, simp)
  apply (erule disjE, simp)
  apply (elim conjE exE, simp)
  apply (simp add: par_tr_head)
  apply (simp add: not_None_T)
  apply (rule_tac x="a" in exI)
  apply (rule_tac x="sb" in exI, simp)
  apply (simp add: Parallel_mem SKIP_mem)
  apply (fast)

(* <= *)

 apply (rule)
 apply (simp add: Ext_pre_choice_mem)
 apply (erule disjE, simp)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
  apply (simp_all)

  apply (rule_tac x="[]t" in exI)
  apply (rule_tac x="[Ev a]t @t ta" in exI, simp)
  apply (simp add: par_tr_head)
  apply (simp add: Ext_pre_choice_mem)
  apply (fast)

  apply (rule_tac x="[Tick]t" in exI)
  apply (rule_tac x="[Ev a]t @t ta" in exI, simp)
  apply (simp add: par_tr_head)
  apply (simp add: Ext_pre_choice_mem)
  apply (fast)
done

(*** domF ***)

lemma domF_Parallel_preterm_l_set1: 
  "[| Ya - insert Tick (Ev ` X) = Z - insert Tick (Ev ` X) ; Ev ` Y Int Z = {} |]
   ==> Ev ` (Y - X) Int (Ya Un Z) = {}"
by (auto)

lemma domF_Parallel_preterm_l: 
  "[[SKIP |[X]| (? :Y -> Qf)]]F = [[? x:(Y-X) -> (SKIP |[X]| Qf x)]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
 apply (simp add: Ext_pre_choice_mem)
 apply (insert trace_nil_or_Tick_or_Ev)
 apply (elim disjE conjE exE)
  apply (simp_all)

  apply (simp add: domF_Parallel_preterm_l_set1)

  apply (drule_tac x="s" in spec)
  apply (simp add: par_tr_not_None)
  apply (erule disjE, simp)
  apply (erule disjE, simp)
  apply (elim conjE exE, simp)
  apply (simp add: par_tr_head)
  apply (simp add: not_None_F)
  apply (simp add: Parallel_mem SKIP_mem)
  apply (fast)

      (* automatized by "par_tr_nil_Tick" *)

  apply (drule_tac x="s" in spec)
  apply (simp add: par_tr_not_None)
  apply (erule disjE, simp)
  apply (erule disjE, simp)
  apply (elim conjE exE, simp)
  apply (simp add: par_tr_head)
  apply (simp add: not_None_F)
  apply (simp add: Parallel_mem SKIP_mem)
  apply (fast)

(* <= *)
 apply (rule)
 apply (simp add: Ext_pre_choice_mem)
 apply (erule disjE, simp)
  apply (simp add: Parallel_mem)
  apply (rule_tac x="Xa - {Tick}" in exI)
  apply (rule_tac x="Xa - (Ev ` X)" in exI)
  apply (rule conjI, fast)
  apply (rule conjI, fast)

  apply (simp add: SKIP_mem)
  apply (rule conjI)
  apply (simp add: Evset_def, fast)
  apply (simp add: Ext_pre_choice_mem)
  apply (fast)

 (* *)
  apply (simp add: Parallel_mem)
  apply (simp add: SKIP_mem)
  apply (elim disjE conjE exE)
  apply (simp_all)
   apply (rule_tac x="Ya" in exI)
   apply (rule_tac x="Z" in exI, simp)
   apply (rule_tac x="[]t" in exI)
   apply (rule_tac x="[Ev a]t @t t" in exI, simp)
   apply (simp add: par_tr_head)
   apply (simp add: Ext_pre_choice_mem)
   apply (fast)

   apply (rule_tac x="Ya" in exI)
   apply (rule_tac x="Z" in exI, simp)
   apply (rule_tac x="[Tick]t" in exI)
   apply (rule_tac x="[Ev a]t @t t" in exI, simp)
   apply (simp add: par_tr_head)
   apply (simp add: Ext_pre_choice_mem)
   apply (fast)
done

(*** domSF ***)

lemma domSF_Parallel_preterm_l:
  "[[SKIP |[X]| (? :Y -> Qf)]]SF = [[? x:(Y-X) -> (SKIP |[X]| Qf x)]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_Parallel_preterm_l)
apply (simp add: domF_Parallel_preterm_l)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_Parallel_preterm_l: 
   "SKIP |[X]| (? :Y -> Qf)
 =SF ? x:(Y-X) -> (SKIP |[X]| Qf x)"
by (simp add: eqSF_def domSF_Parallel_preterm_l)

(*********************************************************
                      P |[X]| SKIP
 *********************************************************)

lemma csp_Parallel_preterm_r: 
   "(? :Y -> Pf) |[X]| SKIP
     =SF ? x:(Y-X) -> (Pf x |[X]| SKIP)"
apply (rule csp_trans)
apply (rule csp_Parallel_commut)
apply (rule csp_trans)
apply (rule csp_Parallel_preterm_l)
apply (rule csp_rm_head, simp)
apply (rule csp_Parallel_commut)
done

(*********************************************************
                    SKIP |[X]| SKIP
 *********************************************************)

(*** domT ***)

lemma domT_Parallel_term:
  "[[SKIP |[X]| SKIP]]T = [[SKIP]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
  apply (simp_all)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (erule disjE, simp)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
done

(*** domF ***)

lemma domF_Parallel_term:
  "[[SKIP |[X]| SKIP]]F = [[SKIP]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Parallel_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
  apply (simp_all)
  apply (fast)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (erule disjE)
  apply (simp add: Parallel_mem)
  apply (simp add: SKIP_mem)
  apply (fast)
  apply (simp add: Parallel_mem)
  apply (simp add: SKIP_mem)
  apply (fast)
done

(*** domSF ***)

lemma domSF_Parallel_term:
  "[[SKIP |[X]| SKIP]]SF = [[SKIP]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_Parallel_term)
apply (simp add: domF_Parallel_term)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_Parallel_term:
   "SKIP |[X]| SKIP =SF SKIP"
by (simp add: eqSF_def domSF_Parallel_term)

(*********************************************************
                      SKIP -- X
 *********************************************************)

(*** domT ***)

lemma domT_SKIP_Hiding_Id:
  "[[SKIP -- X]]T = [[SKIP]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Hiding_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
 apply (simp_all)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (erule disjE, simp)
 apply (simp add: Hiding_mem)
 apply (rule_tac x="[Tick]t" in exI)
 apply (simp add: SKIP_mem)
done

(*** domF ***)

lemma domF_SKIP_Hiding_Id:
  "[[SKIP -- X]]F = [[SKIP]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Hiding_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
 apply (simp_all)
 apply (fast)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (simp add: Hiding_mem)
 apply (simp add: SKIP_mem)
 apply (erule disjE)
  apply (rule_tac x="[]t" in exI)
  apply (simp add: Evset_def, fast)
  apply (rule_tac x="[Tick]t" in exI)
  apply (simp)
done

(*** domSF ***)

lemma domSF_SKIP_Hiding_Id:
  "[[SKIP -- X]]SF = [[SKIP]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_SKIP_Hiding_Id)
apply (simp add: domF_SKIP_Hiding_Id)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_SKIP_Hiding_Id: 
   "SKIP -- X =SF SKIP"
by (simp add: eqSF_def domSF_SKIP_Hiding_Id)

(*********************************************************
                      SKIP [[r]]
 *********************************************************)

(*** domT ***)

lemma domT_SKIP_Renaming_Id:
  "[[SKIP [[r]]]]T = [[SKIP]]T"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Renaming_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
 apply (simp_all)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (erule disjE, simp)
 apply (simp add: Renaming_mem)
 apply (simp add: SKIP_mem)
done

(*** domF ***)

lemma domF_SKIP_Renaming_Id:
  "[[SKIP [[r]]]]F = [[SKIP]]F"
apply (rule eq_iffI)

(* => *)
 apply (rule)
 apply (simp add: Renaming_mem)
 apply (simp add: SKIP_mem)
 apply (elim disjE conjE exE)
 apply (simp_all)

(* <= *)
 apply (rule)
 apply (simp add: SKIP_mem)
 apply (simp add: Renaming_mem)
 apply (simp add: SKIP_mem)
 apply (erule disjE)
 apply (simp_all)
done

(*** domSF ***)

lemma domSF_SKIP_Renaming_Id:
  "[[SKIP [[r]]]]SF = [[SKIP]]SF"
apply (simp add: proc_eqSF_decompo)
apply (simp add: domT_SKIP_Renaming_Id)
apply (simp add: domF_SKIP_Renaming_Id)
done

(*------------------*
 |      csp law     |
 *------------------*)

lemma csp_SKIP_Renaming_Id: 
   "SKIP [[r]] =SF SKIP"
by (simp add: eqSF_def domSF_SKIP_Renaming_Id)

(****************** to add them again ******************)

declare not_None_eq    [simp]

end
