           (*-------------------------------------------*
            |                CSP-Prover                 |
            |                June 2005                  |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Constant_cms = Domain_SF_prod_cms:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*****************************************************************

         1. Constant : map
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                   map SKIP T
 *********************************************************)

(*** restT (subset) ***)

lemma Constant_map_alpha: "0 <= alpha ==> map_alpha (%x. C) alpha"
apply (simp add: map_alpha_def)
apply (simp add: real_mult_order_eq)
done

(*** Constant_non_expanding ***)

lemma Constant_non_expanding: "non_expanding (%x. C)"
by (simp add: non_expanding_def Constant_map_alpha)

(*** Constant_contraction_alpha ***)

lemma Constant_contraction_alpha:
   "[| 0 <= alpha ; alpha < 1 |] ==> contraction_alpha (%x. C) alpha"
by (simp add: contraction_alpha_def Constant_map_alpha)

(****************** to add them again ******************)

declare disj_not1   [simp]
declare not_None_eq [simp]

end
