           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DIV = CSP_semantics:

(*****************************************************************

         1. (DIVt, DIVf) : domSF
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                     domT and domF
 *********************************************************)

(*** DIV_memT ***)

lemma DIVt_memT: "(t :t DIVt) = (t = []t)"
by (simp add: evalt_def evalT_def memT_def Abs_domT_inverse)

lemma DIV_memT: "(t :t [[DIV]]T) = (t = []t)"
by (simp add: DIVt_memT evalT_def)

(*** DIV_memF ***)

lemma DIVf_memF : "(f ~:f DIVf)"
apply (simp add: evalf_def memF_def evalF_def)
by (simp add: Abs_domF_inverse empF_def)

lemma DIV_memF : "(f ~:f [[DIV]]F)"
by (simp add: DIVf_memF evalF_def)

lemmas DIV_mem = DIV_memT DIV_memF DIVt_memT DIVf_memF

(*******************************
       DIVsf in domSF
 *******************************)

(* T2 *)

lemma DIV_T2 : "HC_T2 (DIVt, DIVf)"
by (simp add: HC_T2_def DIV_mem)

(* F3 *)

lemma DIV_F3 : "HC_F3 (DIVt, DIVf)"
by (simp add: HC_F3_def DIV_mem)

(* T3_F4 *)

lemma DIV_T3_F4 : "HC_T3_F4 (DIVt, DIVf)"
by (simp add: HC_T3_F4_def DIV_mem)

(*** DIV_domSF ***)

lemma DIV_domSF : "(DIVt, DIVf) : domSF"
apply (simp add: domSF_iff)
apply (simp add: DIV_T2)
apply (simp add: DIV_F3)
apply (simp add: DIV_T3_F4)
done

end
