           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Proc_name = CSP_semantics_exp:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*********************************************************
                        DomSF
 *********************************************************)

(*** Proc_name_memSF ***)

lemma Proc_name_evalSF: 
  "(fstSF (X pn), sndSF (X pn)) : domSF"
apply (simp add: fstSF_def sndSF_def)
done

(*********************************************************
                      mono
 *********************************************************)

(*** T ***)

lemma Proc_name_evalT_mono:
  "x <= y ==> fstSF (x pn) <= fstSF (y pn)"
apply (simp add: fstSF_def)
apply (simp add: order_prod_def)
apply (drule_tac x="pn" in spec)
apply (simp add: subsetSF_def)
apply (simp add: order_pair_def)
done

(*** F ***)

lemma Proc_name_evalF_mono:
  "x <= y ==> sndSF (x pn) <= sndSF (y pn)"
apply (simp add: sndSF_def)
apply (simp add: order_prod_def)
apply (drule_tac x="pn" in spec)
apply (simp add: subsetSF_def)
apply (simp add: order_pair_def)
done

(****************** to add them again ******************)

declare disj_not1   [simp]
declare not_None_eq [simp]

end
