           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Proc_name_cms = Proc_name + Domain_SF_prod_cms:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*****************************************************************

         1. (%x. x pn) : non expanding
         2.
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                   map Proc_name T
 *********************************************************)

(*** restSF (sub) ***)

lemma Proc_name_restSF:
   "x1 rest n = x2 rest n
    ==> (x1 pn) rest n = (x2 pn) rest n"
apply (simp add: prod_restriction_def)
apply (simp add: expand_fun_eq)
done

(*** Proc_name_evalSF_non_expanding ***)

lemma Proc_name_evalSF_non_expanding:
 "non_expanding (%x. x pn)"
apply (simp add: non_expanding_def map_alpha_def)
apply (intro allI)
apply (rule rest_distance_subset)
apply (intro allI impI)
apply (rule Proc_name_restSF, simp)
done

(****************** to add them again ******************)

declare disj_not1   [simp]
declare not_None_eq [simp]

end
