           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               February 2005               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory Renaming_cpo = Renaming + Domain_SF_prod_cpo:

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare disj_not1 [simp del]

(*  The following simplification is sometimes unexpected.              *)
(*                                                                     *)
(*             not_None_eq: (x ~= None) = (EX y. x = Some y)           *)

declare not_None_eq [simp del]

(*  The following simplification rules are deleted in this theory file *)
(*  because they unexpectly rewrite UnionT and InterT.                 *)
(*                  Union (B ` A) = (UN x:A. B x)                      *)
(*                  Inter (B ` A) = (INT x:A. B x)                     *)
(*                  disj_not1: (~ P | Q) = (P --> Q)                   *)

declare Union_image_eq [simp del]
declare Inter_image_eq [simp del]

(*****************************************************************

         1. (%x. (T x) [[r]]t) : continuous
         2. (%x. (F x) [[r]]f) : continuous
         3. 
         4. 

 *****************************************************************)

(*** Renaming_evalT_continuous ***)

lemma Renaming_evalT_continuous:
 "continuous T ==> continuous (%x. (T x) [[r]]t)"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)

apply (rule_tac x="x" in exI, simp)
apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionT)
apply (rule eq_iffI)

(* <= *)
 apply (rule)
 apply (simp add: memT_UnionT)
 apply (simp only: Renaming_mem)
 apply (simp add: memT_UnionT)
 apply (fast)

(* => *)
 apply (rule)
 apply (simp add: memT_UnionT)
 apply (simp only: Renaming_mem)
 apply (simp add: memT_UnionT)
 apply (fast)

by (simp add: directed_def)

(*** Renaming_evalF_continuous ***)

lemma Renaming_evalF_continuous:
 "continuous F ==> continuous (%x. (F x) [[r]]f)"
apply (simp add: continuous_iff)
apply (intro allI impI)
apply (drule_tac x="X" in spec, simp)
apply (elim conjE exE)

apply (rule_tac x="x" in exI, simp)
apply (subgoal_tac "X ~= {}")
apply (simp add: isLUB_UnionF)
apply (rule eq_iffI)

(* <= *)
 apply (rule)
 apply (simp add: memF_UnionF)
 apply (simp only: Renaming_mem)
 apply (simp add: memF_UnionF)
 apply (fast)

(* => *)
 apply (rule)
 apply (simp add: memF_UnionF)
 apply (simp only: Renaming_mem)
 apply (simp add: memF_UnionF)
 apply (fast)

by (simp add: directed_def)

(****************** to add them again ******************)

declare Union_image_eq [simp]
declare Inter_image_eq [simp]
declare disj_not1      [simp]
declare not_None_eq    [simp]

end
