           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory SKIP = CSP_semantics:

(*****************************************************************

         1. (SKIPt, SKIPf) : domSF
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                     domT and domF
 *********************************************************)

(*** SKIP_memT ***)

lemma SKIPt_memT: "(t :t SKIPt) = (t = []t | t = [Tick]t)"
by (simp add: evalt_def evalT_def memT_def Abs_domT_inverse)

lemma SKIP_memT: "(t :t [[SKIP]]T) = (t = []t | t = [Tick]t)"
by (simp add: evalT_def SKIPt_memT)

(*** SKIP_domF ***)

lemma SKIP_domF: "{f. (EX X. f = ([]t, X) & X <= Evset) |
                      (EX X. f = ([Tick]t, X)) } : domF"
by (auto simp add: domF_def HC_F2_def)

(*** SKIPf_memF ***)

lemma SKIPf_memF :
  "(f :f SKIPf) = ((EX X. f = ([]t, X) & X <= Evset) |
                          (EX X. f = ([Tick]t, X)))"
apply (simp add: evalf_def memF_def evalF_def)
by (simp add: SKIP_domF Abs_domF_inverse)

lemma SKIP_memF :
  "(f :f [[SKIP]]F) = ((EX X. f = ([]t, X) & X <= Evset) |
                          (EX X. f = ([Tick]t, X)))"
by (simp add: evalF_def SKIPf_memF)

lemmas SKIP_mem = SKIP_memT SKIP_memF SKIPt_memT SKIPf_memF

(*******************************
             domSF
 *******************************)

(* T2 *)

lemma SKIP_T2 : "HC_T2 (SKIPt, SKIPf)"
by (simp add: HC_T2_def SKIP_mem)

(* F3 *)

lemma SKIP_F3 : "HC_F3 (SKIPt, SKIPf)"
apply (simp add: HC_F3_def SKIP_mem)
by (auto simp add: Evset_def)

(* T3_F4 *)

lemma SKIP_T3_F4 : "HC_T3_F4 (SKIPt, SKIPf)"
by (simp add: HC_T3_F4_def SKIP_mem)

(*** SKIP_domSF ***)

lemma SKIP_domSF : "(SKIPt, SKIPf) : domSF"
apply (simp add: domSF_iff)
apply (simp add: SKIP_T2)
apply (simp add: SKIP_F3)
apply (simp add: SKIP_T3_F4)
done

end
