           (*-------------------------------------------*
            |                CSP-Prover                 |
            |               December 2004               |
            |               June 2005 (modified)        |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory STOP = CSP_semantics:

(*****************************************************************

         1. (STOPt, STOPf) : domSF
         2. 
         3. 
         4. 

 *****************************************************************)

(*********************************************************
                     domT and domF
 *********************************************************)

(*** STOP_memT ***)

lemma STOPt_memT: "(t :t STOPt) = (t = []t)"
by (simp add: evalt_def evalT_def memT_def Abs_domT_inverse)

lemma STOP_memT: "(t :t [[STOP]]T) = (t = []t)"
by (simp add: STOPt_memT evalT_def)

(*** STOP_domF ***)

lemma STOP_domF: "{f. EX X. f = ([]t, X)} : domF"
by (simp add: domF_def HC_F2_def)

(*** STOP_memF ***)

lemma STOPf_memF : "(f :f STOPf) = (EX X. f = ([]t, X))"
apply (simp add: evalf_def)
apply (simp add: memF_def evalF_def)
by (simp add: STOP_domF Abs_domF_inverse)

lemma STOP_memF : "(f :f [[STOP]]F) = (EX X. f = ([]t, X))"
by (simp add: STOPf_memF evalF_def)

lemmas STOP_mem = STOP_memT STOP_memF STOPt_memT STOPf_memF

(*******************************
             domSF
 *******************************)

(* T2 *)

lemma STOP_T2 : "HC_T2 (STOPt, STOPf)"
by (simp add: HC_T2_def STOP_mem)

(* F3 *)

lemma STOP_F3 : "HC_F3 (STOPt, STOPf)"
by (simp add: HC_F3_def STOP_mem)

(* T3_F4 *)

lemma STOP_T3_F4 : "HC_T3_F4 (STOPt, STOPf)"
by (simp add: HC_T3_F4_def STOP_mem)

(*** STOP_domSF ***)

lemma STOP_domSF : "(STOPt, STOPf) : domSF"
apply (simp add: domSF_iff)
apply (simp add: STOP_T2)
apply (simp add: STOP_F3)
apply (simp add: STOP_T3_F4)
done

end
