           (*-------------------------------------------*
            |    Example 1 [Roscoe_Dathi_1987 P.10]     |
            |  Self-timed version of a systolic array   |
            |                 June 2005                 |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory SA_expanding = SA_definition:

(*********************************************************
              Element process expanding
 *********************************************************)

(* in *)

lemma pe_expand_in:
     "(FIX[Suc (Suc (n + n))] Fun) (pe (i,j) r)
    =SF ? a:(range (vert (i, j)) Un range (hori (i, j)))
     -> IF (a:range (vert (i, j)))
        THEN ? b:range (hori (i, j)) ->
       (FIX[Suc (n + n)] Fun) (pe' (i, j) r (inv (vert (i, j)) a) (inv (hori (i, j)) b))
        ELSE ? b:range (vert (i, j)) -> 
       (FIX[Suc (n + n)] Fun) (pe' (i, j) r (inv (vert (i, j)) b) (inv (hori (i, j)) a))" 
apply (simp add: FIXn_def)
apply (simp add: Fun_def)
apply (simp add: csp_ss_def)
apply (tactic {* csp_hnf_left_tac 1 *})+
apply (rule csp_decompo)
apply (simp)
apply (simp)
apply (erule disjE)
apply (tactic {* csp_simp_tac 1 *})
apply (simp add: image_iff, elim exE, simp)
apply (tactic {* csp_simp_tac 1 *})
apply (simp add: image_iff, elim exE, simp)
done

(* out *)

lemma pe_expand_out:
   "(FIX[Suc (n + n)] Fun) (pe' (i, j) r x y)
    =SF 
    ? a:{vert (Suc i, j) x, hori (i, Suc j) y}
      -> (IF (a = vert (Suc i, j) x) 
          THEN ? z:{hori (i, Suc j) y} -> (FIX[n + n] Fun) (pe (i,j) (r + x * y))
          ELSE ? z:{vert (Suc i, j) x} -> (FIX[n + n] Fun) (pe (i,j) (r + x * y)))"
apply (simp add: FIXn_def)
apply (simp add: Fun_def)
apply (simp add: csp_ss_def)
apply (tactic {* csp_hnf_left_tac 1 *})+
apply (rule csp_decompo)
apply (fast)
apply (tactic {* csp_simp_tac 1 *})
apply (erule disjE)
apply (tactic {* csp_simp_tac 1 *})
apply (tactic {* csp_hnf_left_tac 1 *})+
apply (rule csp_decompo)
apply (simp)
apply (tactic {* csp_hnf_left_tac 1 *})+

apply (tactic {* csp_simp_tac 1 *})
apply (rule csp_decompo)
apply (simp)
apply (tactic {* csp_hnf_left_tac 1 *})+
done

(*********************************************************
                  alphabet lemma
 *********************************************************)

lemma EX1_isFailureOf_in_alpha1:
"([]t, Ev ` Alpha_pe (i, j) - Ev ` (range (vert (i, j)) Un range (hori (i, j))))
= ([]t, {Ev a |a. EX x. a = vert (Suc i, j) x | a = hori (i, Suc j) x})"
by (auto simp add: Alpha_pe.simps)

lemma EX1_isFailureOf_in_alpha2:
"({([Ev (vert (i, j) x)]t @t s, Y) |x s Y.
           (s, Y) : Faiures_in_hori x (i, j) F} Un
          {([Ev (hori (i, j) y)]t @t s, Y) |y s Y.
           (s, Y) : Faiures_in_vert y (i, j) F}) =
{([Ev a]t @t s, Y) |a s Y.
          (s, Y)
          : (if a : range (vert (i, j))
             then Faiures_in_hori (inv (vert (i, j)) a) (i, j) F
             else Faiures_in_vert (inv (hori (i, j)) a) (i, j) F) &
          a : range (vert (i, j)) Un range (hori (i, j))}"
apply (auto)
apply (rule_tac x="vert (i, j) x" in exI)
apply (simp)
apply (fast)
apply (rule_tac x="hori (i, j) y" in exI)
apply (simp add: image_iff)
apply (fast)
done

lemma EX1_isFailureOf_in_hori_alpha1:
  "([]t, {Ev a |a.
                 EX x. a = vert (i, j) x |
                       a = hori (i, Suc j) x | a = vert (Suc i, j) x})
 = ([]t, Ev ` Alpha_pe (i, j) - Ev ` range (hori (i, j)))"
by (auto simp add: Alpha_pe.simps)

lemma EX1_isFailureOf_in_hori_alpha2:
  "{([Ev (hori (i, j) y)]t @t s, Y) |y s Y.
          (s, Y) : Faiures_out (inv (vert (i, j)) a) y (i, j) F} =
  {([Ev aa]t @t s, Y) |aa s Y.
          (s, Y) : Faiures_out (inv (vert (i, j)) a) (inv (hori (i, j)) aa) (i, j) F &
          aa : range (hori (i, j))}"
apply (auto)
apply (rule_tac x="hori (i, j) y" in exI)
apply (auto)
done

lemma EX1_isFailureOf_in_vert_alpha1:
  "([]t, {Ev a |a.
          EX x. a = hori (i, j) x | a = vert (Suc i, j) x | a = hori (i, Suc j) x})
   = ([]t, Ev ` Alpha_pe (i, j) - Ev ` range (vert (i, j)))"
by (auto simp add: Alpha_pe.simps)

lemma EX1_isFailureOf_in_vert_alpha2:
  "{([Ev (vert (i, j) x)]t @t s, Y) |x s Y.
          (s, Y) : Faiures_out x (inv (hori (i, j)) a) (i, j) F} =
   {([Ev aa]t @t s, Y) |aa s Y.
          (s, Y) : Faiures_out (inv (vert (i, j)) aa) (inv (hori (i, j)) a) (i, j) F &
          aa : range (vert (i, j))}"
apply (auto)
apply (rule_tac x="vert (i, j) x" in exI)
by (auto)

lemma EX1_isFailureOf_out_alpha1:
   "([]t, {Ev a |a.
           EX z. a = hori (i, j) z |
                 a = vert (i, j) z |
                 a = hori (i, Suc j) z & z ~= y | a = vert (Suc i, j) z & z ~= x})
  = ([]t, Ev ` Alpha_pe (i, j) - Ev ` {vert (Suc i, j) x, hori (i, Suc j) y})"
by (auto simp add: Alpha_pe.simps)

lemma EX1_isFailureOf_out_alpha2:
"({([Ev (vert (Suc i, j) x)]t @t s, Y) |s Y.
           (s, Y) : Faiures_out_hori y (i, j) F} Un
          {([Ev (hori (i, Suc j) y)]t @t s, Y) |s Y.
           (s, Y) : Faiures_out_vert x (i, j) F}) =
{([Ev a]t @t s, Y) |a s Y.
          (s, Y)
          : (if a : range (vert (Suc i, j)) then Faiures_out_hori y (i, j) F
             else Faiures_out_vert x (i, j) F) &
          a : {vert (Suc i, j) x, hori (i, Suc j) y}}"
by (auto simp add: image_iff)

(*********************************************************
                  isFailureOf
 *********************************************************)

(*** out ***)

lemma EX1_isFailureOf_out_hori:
   "ALL (r::'r::ring). peF_rec n (i, j) <=cut[Ev ` Alpha_pe (i, j)] 
           [[(FIX[n + n] Fun) (pe (i, j) r)]]F
         ==> Faiures_out_hori y (i, j) (peF_rec n (i, j))
             <=cut[Ev ` Alpha_pe (i, j)] 
             [[IF True 
               THEN ? z:{hori (i, Suc j) y} 
                     -> (FIX[n + n] Fun) (pe (i, j) ((r::'r::ring) + x * y)) 
               ELSE ? z:{vert (Suc i, j) x} 
                     -> (FIX[n + n] Fun) (pe (i, j) (r + x * y))]]F"
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _  "(%b. peF_rec n (i, j))"])
apply (tactic {* csp_simp_left_tac 1 *})
apply (simp add: Faiures_out_hori_def)
apply (auto simp add: Alpha_pe.simps)
done


lemma EX1_isFailureOf_out_vert:
    "ALL (r::'r::ring). peF_rec n (i, j) <=cut[Ev ` Alpha_pe (i, j)] 
               [[(FIX[n + n] Fun) (pe (i, j) r)]]F 
         ==> Faiures_out_vert x (i, j) (peF_rec n (i, j))
             <=cut[Ev ` Alpha_pe (i, j)] 
             [[IF False 
               THEN ? z:{hori (i, Suc j) y} 
                     -> (FIX[n + n] Fun) (pe (i, j) ((r::'r::ring) + x * y)) 
               ELSE ? z:{vert (Suc i, j) x} 
                     -> (FIX[n + n] Fun) (pe (i, j) (r + x * y))]]F"
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _  "(%b. peF_rec n (i, j))"])
apply (tactic {* csp_simp_left_tac 1 *})
apply (simp add: Faiures_out_vert_def)
apply (auto simp add: Alpha_pe.simps)
done

lemma EX1_isFailureOf_out:
      "ALL (r::'r::ring).
          peF_rec n (i, j) <=cut[Ev ` Alpha_pe (i, j)] 
          [[(FIX[n + n] Fun) (pe (i, j) r)]]F
       ==> Faiures_out x y (i, j) (peF_rec n (i, j))
           <=cut[Ev ` Alpha_pe (i, j)] 
           [[(FIX[Suc (n + n)] Fun) (pe' (i, j) (r::'r::ring) x y)]]F"
apply (simp add: Faiures_out_def)
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _ 
 "(%a. if (a : range (vert (Suc i, j)))
       then Faiures_out_hori y (i, j) (peF_rec n (i, j))
       else Faiures_out_vert x (i, j) (peF_rec n (i, j)))"])
apply (rule pe_expand_out)
apply (simp only: EX1_isFailureOf_out_alpha1 EX1_isFailureOf_out_alpha2)

apply (rule ballI)
apply (simp)
apply (erule disjE)
apply (simp)
apply (simp add: EX1_isFailureOf_out_hori)
apply (subgoal_tac "a ~: range (vert (Suc i, j))")
apply (simp add: EX1_isFailureOf_out_vert)
by (auto)

(*** in ***)

lemma EX1_isFailureOf_in_hori:
   "[| ALL (r::'r::ring). peF_rec n (i, j) <=cut[Ev ` Alpha_pe (i, j)] 
             [[(FIX[n + n] Fun) (pe (i, j) r)]]F;
          a : range (vert (i, j)) |]
       ==> Faiures_in_hori (inv (vert (i, j)) a) (i, j) (peF_rec n (i, j))
           <=cut[Ev ` Alpha_pe (i, j)] 
           [[IF True 
             THEN ? b:range (hori (i, j)) 
                   -> (FIX[Suc (n + n)] Fun)
                       (pe' (i, j) (r::'r::ring) (inv (vert (i, j)) a)
                         (inv (hori (i, j)) b)) 
             ELSE ? b:range (vert (i, j)) 
                   -> (FIX[Suc (n + n)] Fun)
                       (pe' (i, j) r (inv (vert (i, j)) b)
                         (inv (hori (i, j)) a))]]F"
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _ 
 "(%b. Faiures_out (inv (vert (i, j)) a) (inv (hori (i, j)) b) (i, j) 
       (peF_rec n (i, j)))"])
apply (tactic {* csp_simp_left_tac 1 *})
apply (simp add: Faiures_in_hori_def)
apply (simp only: EX1_isFailureOf_in_hori_alpha1 EX1_isFailureOf_in_hori_alpha2)
apply (auto)
apply (simp add: EX1_isFailureOf_out)
done

lemma EX1_isFailureOf_in_vert:
   "[| ALL (r::'r::ring). peF_rec n (i, j) <=cut[Ev ` Alpha_pe (i, j)] 
               [[(FIX[n + n] Fun) (pe (i, j) r)]]F;
            a : range (hori (i, j)); a ~: range (vert (i, j)) |]
         ==> Faiures_in_vert (inv (hori (i, j)) a) (i, j) (peF_rec n (i, j))
             <=cut[Ev ` Alpha_pe (i, j)] 
             [[IF False 
               THEN ? b:range (hori (i, j)) 
                     -> (FIX[Suc (n + n)] Fun)
                         (pe' (i, j) (r::'r::ring) (inv (vert (i, j)) a)
                           (inv (hori (i, j)) b)) 
               ELSE ? b:range (vert (i, j)) 
                     -> (FIX[Suc (n + n)] Fun)
                         (pe' (i, j) r (inv (vert (i, j)) b)
                           (inv (hori (i, j)) a))]]F"
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _ 
 "(%b. Faiures_out (inv (vert (i, j)) b) (inv (hori (i, j)) a) (i, j) 
       (peF_rec n (i, j)))"])
apply (tactic {* csp_simp_left_tac 1 *})
apply (simp add: Faiures_in_vert_def)
apply (simp only: EX1_isFailureOf_in_vert_alpha1 EX1_isFailureOf_in_vert_alpha2)
apply (auto)
apply (simp add: EX1_isFailureOf_out)
done

lemma EX1_isFailureOf_in:
      "ALL (r::'r::ring). peF_rec n (i, j)
              <=cut[Ev ` Alpha_pe (i, j)] 
                   [[(FIX[n + n] Fun) (pe (i,j) r)]]F
       ==> Faiures_in (i, j) (peF_rec n (i, j))
           <=cut[Ev ` Alpha_pe (i, j)] 
                [[(FIX[Suc (Suc (n + n))] Fun) (pe (i,j) (r::'r::ring))]]F"
apply (simp add: Faiures_in_def)
apply (rule csp_evalF_cut_Ext_pre_choice [of _ _ _ _ _ 
 "(%a. if (a : range (vert (i, j)))
       then Faiures_in_hori (inv (vert (i, j)) a) (i, j) (peF_rec n (i, j))
       else Faiures_in_vert (inv (hori (i, j)) a) (i, j) (peF_rec n (i, j)))"])
apply (rule pe_expand_in)
apply (simp only: EX1_isFailureOf_in_alpha1 EX1_isFailureOf_in_alpha2)

apply (intro ballI)
apply (simp)
apply (erule disjE)
apply (simp)
apply (simp add: EX1_isFailureOf_in_hori)
apply (subgoal_tac "a ~: range (vert (i, j))")
apply (simp)
apply (simp add:  EX1_isFailureOf_in_vert)
by (auto)

lemma EX1_isFailureOf_in_ALL:
      "ALL (r::'r::ring). peF_rec n (i, j)
              <=cut[Ev ` Alpha_pe (i, j)] 
                   [[(FIX[n + n] Fun) (pe (i,j) r)]]F"
apply (induct_tac n)
apply (simp add: FIXn_def)
apply (rule allI)
apply (simp add: EX1_isFailureOf_in)
done

(*** main ***)

lemma EX1_isFailureOf:
   "(Systolic_ArrayF N) isFailureOf (Systolic_Array N)"
apply (simp add: isFailureOf_def)
apply (simp add: Systolic_Array_def Systolic_ArrayF_def)
apply (rule ballI)
apply (subgoal_tac "(FIX Fun) (pe i 0) =SF 
      (!nat n .. ((FIX[n + n] Fun) (pe i 0)))")
apply (rule csp_evalF_cut_eqSF)
apply (simp)
apply (rule csp_evalF_cut_Rep_int_choice_nat_UNIV)
apply (rule csp_decompo)
apply (simp_all)
apply (rule csp_reflex)
apply (subgoal_tac "peF i = Union {peF_rec n i |n. True}")
apply (simp)
apply (simp add: peF_def)

apply (rule allI)
apply (simp add: Example1_index_mem)
apply (elim conjE exE)
apply (simp add: EX1_isFailureOf_in_ALL)
apply (simp add: csp_FIX_plus_eq)
done

end
